/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef AUDIOTRACK_H
#define AUDIOTRACK_H

#include <Wt/Dbo/Dbo>
#include <taglib/tbytevector.h>

class AudioTrack
{
public:
    std::string trackName;
    std::string trackArtistName;
    std::string trackAlbumName;
    std::string trackGenre;
    double trackLengthSeconds;
    std::string trackFingerprint;
    std::string trackPath;
    
    //Non-persisted data
    TagLib::ByteVector coverArt;
    std::string coverMimeType;
    
    template<class Action>
    void persist(Action& a)
    {
        Wt::Dbo::field(a, trackName, "name");    
        Wt::Dbo::field(a, trackArtistName, "artist");
        Wt::Dbo::field(a, trackAlbumName, "album");
        Wt::Dbo::field(a, trackLengthSeconds, "length");
        Wt::Dbo::field(a, trackFingerprint, "fingerprint");
        Wt::Dbo::field(a, trackGenre, "genre");
        Wt::Dbo::field(a, trackPath, "path");
    }
};

#endif
